.486
.model flat

;text segment para use32 public 'data'
_text segment para public use32 'code'

;codeseg

MIN_Z equ -512

;extrn _color             :dword
;extrn _bw                :dword
;extrn _shadow            :dword
extrn _zbuffer           :dword
;extrn _yOffset           :dword
;extrn _ls                :dword
;extrn _zs                :dword
;extrn _txs               :dword
;extrn _tys               :dword
;extrn _x2                :dword

public _shadow
public _colorShadow
public _bwShadow
public _zbufferOffsetShadow
public _yOffsetShadow
public _lsShadow
public _zsShadow
public _txsShadow
public _tysShadow
public _x2Shadow

public _colorNoShadow
public _bwNoShadow
public _yOffsetNoShadow
public _lsNoShadow
public _zsNoShadow
public _txsNoShadow
public _tysNoShadow
public _x2NoShadow

public _bwNoTexture
public _lsNoTexture
public _zsNoTexture
public _x2NoTexture

public DrawLineShadow_
public DrawLineNoShadow_
public DrawLineNoTexture_

;  DrawLine( x1, z1, l1, tx1, ty1 );
;  esi - x1
;  ecx - z1
;  ebx - l1
;  ebp - tx1
;  edx - ty1
;  edi - _zbuffer[x1]

DrawLineShadow_ proc

       push ebp
       mov ebp,eax
       mov edi,_zbuffer
       mov [@patch0+4],edi
       mov [@patch1+4],edi
       align 16
@_loop:
       mov eax,ecx
       shr eax,16
@patch0:
       cmp ax,[12345678+esi*2]
       jle @no_draw
@patch1:
       mov [12345678+esi*2],ax
@zbuffer_patch:
       mov ax,[12345678+esi*2]
       cmp ax,MIN_Z
       jnz @no_shadow
@shadow_patch:
       mov byte ptr [esi+12345678],60
@no_shadow:
       mov eax,edx
       shr eax,16
@yOffset_patch:
       mov edi,[12345678+eax*4]
       mov eax,ebp
       shr eax,16
       add edi,eax
@no_add:
       mov al,byte ptr [edi]
@color_patch:
       mov [esi+12345678],al
       mov eax,ebx
       shr eax,16
@bw_patch:
       mov [esi+12345678],al
@no_draw:
       inc esi
@x2_patch:
       cmp esi,12345678
       jg @exit
       je @_loop
@ls_patch:
       add ebx,12345678
@zs_patch:
       add ecx,12345678
@txs_patch:
       add ebp,12345678
@tys_patch:
       add edx,12345678
       jmp @_loop
@exit:
       pop ebp
       ret
DrawLineShadow_ endp

DrawLineNoShadow_ proc
       push ebp
       mov ebp,eax
       mov edi,_zbuffer
       mov dword ptr [@@patch0+4],edi
       mov dword ptr [@@patch1+4],edi
;       align 16
@@_loop:
       mov eax,ecx
       shr eax,16
@@patch0:
       cmp ax,[12345678+esi*2]
       jle @@no_draw
@@patch1:
       mov [12345678+esi*2],ax
       mov eax,edx
       shr eax,16
@@yOffset_patch:
       mov edi,[12345678+eax*4]
       mov eax,ebp
       shr eax,16
       add edi,eax
       mov al,byte ptr [edi]
@@color_patch:
       mov [esi+12345678],al
       mov eax,ebx
       shr eax,16
@@bw_patch:
       mov [esi+12345678],al
@@no_draw:
       inc esi
@@x2_patch:
       cmp esi,12345678
       jg @@exit
       je @@_loop               ; what are you lookin' at? get lost...
@@ls_patch:
       add ebx,12345678
@@zs_patch:
       add ecx,12345678
@@txs_patch:
       add ebp,12345678
@@tys_patch:
       add edx,12345678
       jmp @@_loop
@@exit:
       pop ebp
       ret
DrawLineNoShadow_ endp

DrawLineNoTexture_ proc

       push ebp
ls_patch:
       mov ebp,12345678
bw_patch:
       mov edx,12345678
       mov edi,_zbuffer
       mov [patch0+4],edi
       mov [patch1+4],edi
       align 16
_loop:
       mov eax,ecx
       shr eax,16
patch0:
       cmp ax,[12345678+esi*2]
       jle no_draw
patch1:
       mov [12345678+esi*2],ax
       mov eax,ebx
       shr eax,16
       mov [esi+edx],al
no_draw:
       inc esi
x2_patch:
       cmp esi,12345678
       jg exit
       je _loop
       add ebx,ebp
zs_patch:
       add ecx,12345678
       jmp _loop
exit:
       pop ebp
       ret
DrawLineNoTexture_ endp

org @zbuffer_patch
    db 4 dup (?)
    _zbufferOffsetShadow dd ?
org @shadow_patch
    db 2 dup (?)
    _shadow dd ?
org @yOffset_patch
    db 3 dup (?)
    _yOffsetShadow dd ?
org @color_patch
    db 2 dup (?)
    _colorShadow dd ?
org @bw_patch
    db 2 dup (?)
    _bwShadow dd ?
org @x2_patch
    db 2 dup (?)
    _x2Shadow dd ?
org @ls_patch
    db 2 dup (?)
    _lsShadow dd ?
org @zs_patch
    db 2 dup (?)
    _zsShadow dd ?
org @txs_patch
    db 2 dup (?)
    _txsShadow dd ?
org @tys_patch
    db 2 dup (?)
    _tysShadow dd ?

org @@yOffset_patch
    db 3 dup (?)
    _yOffsetNoShadow dd ?
org @@color_patch
    db 2 dup (?)
    _colorNoShadow dd ?
org @@bw_patch
    db 2 dup (?)
    _bwNoShadow dd ?
org @@x2_patch
    db 2 dup (?)
    _x2NoShadow dd ?
org @@ls_patch
    db 2 dup (?)
    _lsNoShadow dd ?
org @@zs_patch
    db 2 dup (?)
    _zsNoShadow dd ?
org @@txs_patch
    db 2 dup (?)
    _txsNoShadow dd ?
org @@tys_patch
    db 2 dup (?)
    _tysNoShadow dd ?

org bw_patch
    db 1 dup (?)
    _bwNoTexture dd ?
org x2_patch
    db 2 dup (?)
    _x2NoTexture dd ?
org ls_patch
    db 1 dup (?)
    _lsNoTexture dd ?
org zs_patch
    db 2 dup (?)
    _zsNoTexture dd ?

_text ends

end
