#ifndef __FONT__
#define __FONT__

enum { ALIGN_LEFT,
       ALIGN_RIGHT,
       ALIGN_CENTER };

#include "poly2d.h"

class Font {
  int size;
public:
  TPoly2D* font[256];
  int text_step_x, text_step_y;
  Font( int sizeX, int sizeY );
  void Load( int first, int last, char* _name );
  void Prepare();
  void DrawString( int x, int y, char* s, int aligment,
                   PAGE page, uchar color );
  TPoly2D* getChar( char c ) {
    return font[c] ? font[c] : font[' '];
  }
};

#endif