#include "music.h"
#include "misc.h"
#include "resource.h"
#include "parts.h"

void main( int argc, char* argv[] )
{
  resInit( PROJECT_NAME".EXE" );
  Startup( argc > 1 );
  partInit();
  musLoadModule("vobb.s3m");
  miscStartTimer();
  musStartMusic();

  partTrees(30);
  partTitle(75);
  partFace(110);
  partFire(155);
  partFigs(200);
  partIndy(255);
  partCubes(300);
  musStopMusic();
  musLoadModule("aladeroc.s3m");
  musStartMusic();

  partScroll(422);
  partDone();
  Shutdown();
}