#include <stdio.h>
#include <stdlib.h>

struct entry {
  char name[16];
  int offset, size;
} *table=0;

void main( int argc, char* argv[] )
{
  FILE* f = fopen( argv[1], "rb" );
  if(f) {
    fseek( f, -4, SEEK_END );
    int n;
    fread( &n, sizeof(int), 1, f );
    if( n == 0x12345678 ) {
      fseek( f, -8, SEEK_END );
      fread( &n, sizeof(int), 1, f );
      fseek( f, n, SEEK_SET );
      int resource_number;
      fread( &resource_number, sizeof(int), 1, f );
      table = (entry*)malloc(sizeof(entry)*resource_number);
      fread( table, sizeof(entry)*resource_number, 1, f );
      for( int i=0; i<resource_number; i++ ) {
        printf( "name=%s, size=%d\n", table[i].name, table[i].size );
        FILE* f1 = fopen( table[i].name, "wb" );
        void* buf = malloc( table[i].size );
        fseek( f, table[i].offset, SEEK_SET );
        fread( buf, 1, table[i].size, f );
        fwrite( buf, 1, table[i].size, f1 );
        free(buf);
        fclose(f1);
      }
    }
    fclose(f);
  }
}
